/* SECTION 6.1.5 */
clear
set obs 1
gen k0=.
gen k1=.
gen m1=.

local f0=6.5
local f1=12.25
local C=50000
local m=20
local v0=2
local v1=7
local sigma=126383.5
local rho=.05
local sigmap2=(1-`rho')*(`sigma'^2)
local sigmac2=`rho'*(`sigma'^2)


/*
here optimnising over 3 unknowns:
 ko ,  k1  and  m1
x[1], x[2] and x[3] 
*/
mata: mata clear  
mata: mata set matastrict off 
mata 
void myeval(todo, x,  y, g, H)
{
y = `sigmac2'/x[1]+`sigmap2'/(x[1]*((`C'-`f0'*x[1] - (`f1'+`v1'*x[3])*x[2])/(`v0'*x[1]))) + `sigmac2'/(x[2])+`sigmap2'/(x[3]*x[2])
}
S = optimize_init()
optimize_init_which(S,"min" )
optimize_init_evaluator(S, &myeval())
optimize_init_params(S, (930,600,6))
x = optimize(S)
x
st_store(., "k0", x[1,1])
st_store(., "k1", x[1,2])
st_store(., "m1", x[1,3])

end

local k0=k0[1]
local k1=k1[1]
local m1=m1[1]


local m0=((`C'-`f0'*`k0' - (`f1'+`v1'*`m1')*`k1')/(`v0'*`k0'))

di `k1'
di `k0'
di `m1'
di `m0'
/* internal consistency check to ensure that optimal parameters yield the total cost (here C=50000) when inputted into the cost function */

di `k0'*(`f0'+`v0'*`m0')+`k1'*(`f1'+`v1'*`m1')


